<!doctype html PUBLIC "-//W3C//DTD HTML 4.0//EN">
<html>

<head>

<title> 
Objects
</title>

<style type="text/css">
body {
	margin-top: 0.5in;
	margin-bottom: 0.5in;
	margin-left: auto;
	margin-right: auto;
	width: 7in;
	font-family: Bitstream Charter, Lucida Grande, Georgia, Times, serif;
}

h2 {
	margin-top: 1.25em;
	margin-bottom: 0.5em;
	font-family: Arial, Helvetica, sans-serif;
	font-weight: bolder;
	font-size: 1.4em;
}

p {
}

div.entry {
	border-bottom: solid 1px #cccccc;
	margin-bottom: 1.75em;
	padding-bottom: 1em;
}

div.entry-title {
	margin-top: 1.25em;
	font-family: Arial, Helvetical, sans-serif;
	font-weight: bolder;
	font-size: 1.025em;
}

div.entry-date {
	margin-bottom: 1.05em;
	font-style: italic;
	font-size: x-small;
	color: gray;
}

div.titleless-entry-date {
	margin-bottom: 0.5em;
	font-style: italic;
	font-size: x-small;
	color: gray;
}

div.code {
	margin-bottom: 1em;
	font-family: Courier, monospace;
	font-size: smaller;
	margin-left: 2em;
	margin-right: 2em;
	white-space: pre;
}

</style>

</head>


<body>

<h2>
Objects
</h2>

<div class="entry">
<div class="entry-title"> Functions, Fields, and Shared Fields </div>
<p>
An object may have functions and fields, just like any normal Fonc object.  But fields defined in Trylid always have getter and setter functions defined; that is, they are "public".
</p>

<p>
There is also such a thing as a "shared field", whose value is shared by the prototype and all its clones, much like a "class variable" in class-oriented object-oriented systems.
</p>

<div class="code">proto MyProto
  field my-field

  my-shared-field = 'foo'   # A shared field.

  create: value
    # Each clone has a separate value for "my-field".
    my-field = value

  bar
    return my-shared-field + " " + value string</div>

</div>

<div class="entry">
<div class="entry-title"> Prototypes Act as Classes and as Namespaces </div>
<p>
In a prototype-based system like Fonc, objects act as both instances and as classes.  In Trylid, they also can act as namespaces (a.k.a. packages).  One prototype may be "contained" in another (as a shared field); functions in the child prototype have access to functions in the parent prototype.
</p>

<div class="code">proto WindowSystem
  proto Event
    create: raw-event
      #...

  proto Window
    next-event
      # Notice that it knows the name "Event":
      return Event new: get-raw-event</div>

<p>
There is a top-level namespace called "Trylid", which acts as a global namespace for all Trylid objects.  There is a namespace called "Standard" which contains some common classes.  [Currently, in "Standard", there is a prototype called "Object", from which all Trylid prototypes descend.  In the future, the main Fonc "Object" prototype may be used instead, but it still will likely appear in "Standard", not "Trylid".]  You can access the members of "Standard" without having to specify it explicitly.  A namespace called "Pepsi" (actually "Standard Pepsi") allows access to Pepsi's namespace.  And a namespace called "Posix" contains some prototypes that access types from the Posix C API.
</p>

</div>



</body>
</html>
